VERSION 5.00
Begin VB.Form frmScroll 
   Caption         =   "Scroll"
   ClientHeight    =   6255
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8355
   LinkTopic       =   "Form1"
   ScaleHeight     =   6255
   ScaleWidth      =   8355
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   6480
      TabIndex        =   5
      Top             =   360
      Width           =   1215
   End
   Begin VB.PictureBox picContainer 
      Height          =   5055
      Left            =   0
      ScaleHeight     =   4995
      ScaleWidth      =   6315
      TabIndex        =   0
      Top             =   0
      Width           =   6375
      Begin VB.PictureBox picOuter 
         Height          =   3975
         Left            =   0
         ScaleHeight     =   3915
         ScaleWidth      =   5235
         TabIndex        =   3
         Top             =   0
         Width           =   5295
         Begin VB.PictureBox picInner 
            AutoSize        =   -1  'True
            BorderStyle     =   0  'None
            Height          =   8805
            Left            =   360
            Picture         =   "Scroll2.frx":0000
            ScaleHeight     =   8805
            ScaleWidth      =   12720
            TabIndex        =   4
            Top             =   240
            Width           =   12720
         End
      End
      Begin VB.VScrollBar vbarMarble 
         Height          =   2295
         Left            =   5400
         TabIndex        =   2
         Top             =   0
         Width           =   255
      End
      Begin VB.HScrollBar hbarMarble 
         Height          =   255
         Left            =   0
         TabIndex        =   1
         Top             =   4080
         Width           =   2295
      End
   End
   Begin VB.Label Label1 
      Caption         =   "The picture does not grow into this area."
      Height          =   255
      Left            =   2160
      TabIndex        =   6
      Top             =   5160
      Width           =   3015
   End
End
Attribute VB_Name = "frmScroll"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Arrange the scroll bars.
Private Sub ArrangeControls()
Dim border_width As Single
Dim got_wid As Single
Dim got_hgt As Single
Dim need_wid As Single
Dim need_hgt As Single
Dim need_hbar As Boolean
Dim need_vbar As Boolean

    ' See how much room we have and need.
    border_width = picOuter.Width - picOuter.ScaleWidth
    got_wid = picContainer.ScaleWidth - border_width
    got_hgt = picContainer.ScaleHeight - border_width
    need_wid = picInner.Width
    need_hgt = picInner.Height

    ' See if we need the horizontal scroll bar.
    If need_wid > got_wid Then
        need_hbar = True
        got_hgt = got_hgt - hbarMarble.Height
    End If

    ' See if we need the vertical scroll bar.
    If need_hgt > got_hgt Then
        need_vbar = True
        got_wid = got_wid - vbarMarble.Width

        ' See if we now need the horizontal scroll bar.
        If (Not need_hbar) And need_wid > got_wid Then
            need_hbar = True
            got_hgt = got_hgt - hbarMarble.Height
        End If
    End If

    ' Arrange the controls.
    picOuter.Move 0, 0, got_wid + border_width, got_hgt + border_width
    If need_hbar Then
        hbarMarble.Move 0, got_hgt + border_width, got_wid + border_width
        hbarMarble.Min = 0
        hbarMarble.Max = picInner.ScaleWidth - got_wid
        hbarMarble.SmallChange = got_wid / 5
        hbarMarble.LargeChange = got_wid
        hbarMarble.Visible = True
    Else
        hbarMarble.Value = 0
        hbarMarble.Visible = False
    End If
    If need_vbar Then
        vbarMarble.Move got_wid + border_width, 0, vbarMarble.Width, got_hgt + border_width
        vbarMarble.Min = 0
        vbarMarble.Max = picInner.ScaleHeight - got_hgt
        vbarMarble.SmallChange = got_hgt / 5
        vbarMarble.LargeChange = got_hgt
        vbarMarble.Visible = True
    Else
        vbarMarble.Value = 0
        vbarMarble.Visible = False
    End If
End Sub

Private Sub cmdExit_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    picInner.AutoSize = True
    picInner.Move 0, 0

    ArrangeControls
End Sub


Private Sub picContainer_Resize()
    ArrangeControls
End Sub


' Reposition picInner.
Private Sub hbarMarble_Change()
    picInner.Left = -hbarMarble.Value
End Sub


' Reposition picInner.
Private Sub hbarMarble_Scroll()
    picInner.Left = -hbarMarble.Value
End Sub


' Reposition picInner.
Private Sub vbarMarble_Change()
    picInner.Top = -vbarMarble.Value
End Sub


' Reposition picInner.
Private Sub vbarMarble_Scroll()
    picInner.Top = -vbarMarble.Value
End Sub


